<!--
/* 
 * MailArchiver Expresso Pattern serialized format
 * ---
 * This resources intended to be used on converting data formats, to make
 * it work on ExpressoMail pattern.
 * 
 * Basicly, it gets all the service return data (almost enveloped at SOAP 
 * webservices spec i.e XML data), and then transform it to the serialized
 * pattern used by Expresso (somethink almost close or near JSON Javascript 
 * objects).
 * 
 * @author Fernando Wendt [fernando-alberto.wendt@serpro.gov.br]
 *
 * @status under development
 * 
 */
var MAPattern = function(){
    
}
// -----------------------------------SERIALIZED DATA TEMPLATES ----------------
MAPattern.prototype.toExpressoAddress = function(data){
    if((typeof(data) != 'undefined') && (data.length > 0)){
        var Fromdata = eval("(" + data + ")");
        if(Fromdata.mailbox){
        //just one address to pharse: length is undefined
        if(typeof(Fromdata.mailbox.length) == 'undefined'){
            var dataName = Fromdata.mailbox["@name"];               
            var dataEmail = Fromdata.mailbox["@localPart"] + '@' + Fromdata.mailbox["@domain"];
            if(dataName == 'null')
                dataName = dataEmail;
        }
        //address list to pharse, but to header(folder list messages action), only first metters
        else{
            var dataName = Fromdata.mailbox[0]["@name"];
            var dataEmail = Fromdata.mailbox[0]["@localPart"] + '@' + Fromdata.mailbox[0]["@domain"];
            if(dataName == 'null')
                dataName = dataEmail;
        }

        var tplFrom = 'a:3:{'
+           's:4:"name";'
+           's:'+dataName.length+':"'+dataName+'";'
+           's:5:"email";'
+           's:'+dataEmail.length+':"'+dataEmail+'";'
+           's:4:"full";'
+           's:'+(dataName.length + dataEmail.length + 3)+':"'+dataName+' <'+dataEmail+'>";'
+       '}';
    }
    //Data adrress from mailbox is empty, null, or canot be correctly returned by service invocation (will return 'unknow mailbox' string)
    else {
        tplFrom = 'a:2{s:4:"name";s:14:"Unknow mailbox";s:5:"email";s:15:"Unknow_mailbox";}';
    }
    }
    else{
        tplFrom = 'a:2{s:4:"name";s:14:"Unknow mailbox";s:5:"email";s:15:"Unknow_mailbox";}';
    }
    return(tplFrom);
}

MAPattern.prototype.toExpressoSubject = function(data){
    if((typeof(data) != 'undefined') && (data.length > 0)){
        var tplSbj = 's:'+data.length+':"'+data+'";'
    }
    //Subject is empty, null, or canot be correctly returned by service invocation (will return 'Message without subject' string)
    else {
        tplSbj = 's:25:"[Message without subject]";';
    }
    return(tplSbj);
}

MAPattern.prototype.toExpressoAttachmentsHeader = function(data){
    if((typeof(data) != 'undefined') && (data.length > 0)){
        var Attdata = eval("(" + data + ")");
        if(typeof(Attdata.attachment) != 'undefined'){                    
            var tplAttatch = 'a:2:{'
+               's:5:"names";';
            //More than 1 attachment - because length will be 'undefined' if just one exists
            if(Attdata.attachment.length > 0){
                var strnamesatt = "";
                for(var x=0; x<Attdata.attachment.length; x++){
                  var attId = Attdata.attachment[x]["@id"];
                  var attName = Attdata.attachment[x]["@name"];
                  var attSize = Attdata.attachment[x]["@size"];
                  var attMediaType = Attdata.attachment[x]["@mediaType"];
                  var attSubType = Attdata.attachment[x]["@subType"];
                  var attEncoding = Attdata.attachment[x]["@encoding"];
                  
                  strnamesatt += attName + ', ';
                }
                strnamesatt = strnamesatt.substr(0, strnamesatt.length-2);
                var intnumberatt = Attdata.attachment.length;
            }
            //Just one attachment
            else{
                var attId = Attdata.attachment["@id"];
                var attName = Attdata.attachment["@name"];
                var attSize = Attdata.attachment["@size"];
                var attMediaType = Attdata.attachment["@mediaType"];
                var attSubType = Attdata.attachment["@subType"];
                var attEncoding = Attdata.attachment["@encoding"];
                strnamesatt = attName;
                var intnumberatt = 1;
            }
            
            tplAttatch += 's:'+strnamesatt.length+':"'+strnamesatt+'";'
+               's:18:"number_attachments";i:' +intnumberatt+';'
+           '}';
        }
        else {
            tplAttatch = 'a:2:{s:5:"names";b:0;s:18:"number_attachments";i:0;}';    
        }
    }
    //No attatch data
    else {
        tplAttatch = 'a:2:{s:5:"names";b:0;s:18:"number_attachments";i:0;}';
    }
    return(tplAttatch);
}

MAPattern.prototype.toExpressoDate = function(data){
    var ndate = new Date(data);
    var odate = zeroFill(ndate.getDate()) + '/' + zeroFill(ndate.getMonth()+1) + '/' + zeroFill(ndate.getFullYear() + ' ' + zeroFill(ndate.getHours()) + ':' + zeroFill(ndate.getMinutes()) + ':' + zeroFill(ndate.getSeconds()));
    return(odate);
}

MAPattern.prototype.toExpressoFlags = function(data){
    if((data.length > 0) && (typeof(data) != 'undefined')){
        var Tagdata = eval("(" + data + ")");
        if(typeof(Tagdata.tag) != 'undefined'){ 
        //More than 1 attachment: length will be 'undefined' if just one exists
        if(Tagdata.tag.length >= 0){
            var strnamestag = "";
            for(var x=0; x<Tagdata.tag.length; x++){
                var tagvalue = Tagdata.tag[x]["@value"];
                if(tagvalue.toLowerCase().indexOf('recent')!= -1)
                    strnamestag += 's:6:"Recent";s:1:"N";';
                if(tagvalue.toLowerCase().indexOf('unseen')!= -1)
                    strnamestag += 's:6:"Unseen";s:1:"U";';
                if(tagvalue.toLowerCase().indexOf('deleted')!= -1)
                    strnamestag += 's:7:"Deleted";s:1:"D";';
                if(tagvalue.toLowerCase().indexOf('answered')!= -1)
                    strnamestag += 's:8:"Answered";s:1:"A";';
                if(tagvalue.toLowerCase().indexOf('forwarded')!= -1)
                    strnamestag += 's:9:"Forwarded";s:1:"F";';
                if(tagvalue.toLowerCase().indexOf('draft')!= -1)
                    strnamestag += 's:5:"Draft";s:1:"X";';
                if(tagvalue.toLowerCase().indexOf('importance')!= -1)
                    strnamestag += 's:10:"Importance";s:4:"High";';
                if(tagvalue.toLowerCase().indexOf('flagged')!= -1)
                    strnamestag += 's:7:"Flagged";s:1:"F";';
            } 
            var tplTags = strnamestag; 
          }
          
          else{
            var strnamestag = "";
            var tagvalue = Tagdata.tag["@value"];
                if(tagvalue.toLowerCase().indexOf('recent')!= -1)
                    strnamestag += 's:6:"Recent";s:1:"N";';
                if(tagvalue.toLowerCase().indexOf('unseen')!= -1)
                    strnamestag += 's:6:"Unseen";s:1:"U";';
                if(tagvalue.toLowerCase().indexOf('deleted')!= -1)
                    strnamestag += 's:7:"Deleted";s:1:"D";';
                if(tagvalue.toLowerCase().indexOf('answered')!= -1)
                    strnamestag += 's:8:"Answered";s:1:"A";';
                if(tagvalue.toLowerCase().indexOf('forwarded')!= -1)
                    strnamestag += 's:9:"Forwarded";s:1:"F"';
                if(tagvalue.toLowerCase().indexOf('draft')!= -1)
                    strnamestag += 's:5:"Draft";s:1:"X";';
                if(tagvalue.toLowerCase().indexOf('importance')!= -1)
                    strnamestag += 's:10:"Importance";s:4:"High";';
                if(tagvalue.toLowerCase().indexOf('flagged')!= -1)
                    strnamestag += 's:7:"Flagged";s:1:"F";';
            var tplTags = strnamestag;
          }
      }
      //Something is wrong with tags: return defaults is no one tag
      else{
        tplTags = 's:6:"Recent";s:1:" ";s:6:"Unseen";s:1:" ";s:7:"Deleted";s:1:" ";s:8:"Answered";s:1:" ";s:9:"Forwarded";s:1:" ";s:5:"Draft";s:1:" ";s:10:"Importance";s:6:"Normal";s:7:"Flagged";b:0;';
      }
      return(tplTags);
    }
}

MAPattern.prototype.toExpressoHeader = function(data){   
    var tplHeader = 'a:16:{'
+           's:11:"ContentType";'
+           's:' + data.getContentType().length + ':"' + data.getContentType() + '";'
+           expresso_mail_archive.pattern.toExpressoFlags(data.getTags())
+           's:10:"msg_number";'
+           's:'+data.getId().length+':"'+data.getId()+'";'
+           's:5:"udate";'
+           'i:' + parseInt(data.getDate()/1000) + ';'
+           's:9:"timestamp";'
+           'i:' + parseInt(data.getDate()/1000) + ';'
+           's:4:"from";'
+           expresso_mail_archive.pattern.toExpressoAddress(data.getFrom())
+           's:2:"to";'
+           expresso_mail_archive.pattern.toExpressoAddress(data.getTo())
+           's:7:"subject";'
+           expresso_mail_archive.pattern.toExpressoSubject(data.getSubject())
+           's:4:"Size";'
+           'i:'+data.getSize()+';'
+           's:10:"attachment";'
+           expresso_mail_archive.pattern.toExpressoAttachmentsHeader(data.getAttachments())
+           '}';
    return(tplHeader);
}

MAPattern.prototype.toExpressoBody = function(mheader){
    var tplBody = 'a:33:{'
+                   's:4:"body";N;'
+                   's:11:"attachments";N;'
+                   's:6:"thumbs";N;'
+                   's:9:"signature";N;'
+                   's:10:"Importance";s:6:"Normal";'
+                   's:6:"Recent";s:1:" ";'
+                   's:6:"Unseen";s:1:"N";'
+                   's:7:"Deleted";s:1:" ";'
+                   's:7:"Flagged";b:0;'
+                   's:8:"Answered";s:1:" ";'
+                   's:5:"Draft";s:1:" ";'
+                   's:10:"msg_number";s:4:"2241";'
+                   's:10:"msg_folder";s:5:"INBOX";'
+                   's:5:"udate";s:5:"10:01";'
+                   's:7:"msg_day";s:10:"10/05/2011";'
+                   's:8:"msg_hour";s:5:"10:02";'
+                   's:8:"fulldate";s:36:"10/05/2011 10:01 (05:35 horas atras)";'
+                   's:9:"smalldate";s:5:"10:04";'
+                   's:4:"from";N;'
+                   's:6:"sender";a:3:{'
+                       's:4:"name";N;'
+                       's:5:"email";s:46:"listaregional-pae-bounces@grupos.serpro.gov.br";'
+                       's:4:"full";s:46:"listaregional-pae-bounces@grupos.serpro.gov.br";'
+                   '}'
+                   's:10:"toaddress2";s:32:"comunicacao.social@serpro.gov.br";'
+                   's:2:"cc";N;'
+                   's:3:"bcc";N;'
+                   's:8:"reply_to";N;'
+                   's:7:"subject";N;'
+                   's:4:"Size";s:4:"1234";'
+                   's:15:"reply_toaddress";s:45:"com.social <comunicacao.social@serpro.gov.br>";'
+                   's:9:"timestamp";i:1305032476;'
+                   's:5:"login";i:944889240;'
+                   's:6:"header";a:16:{'
+                      's:11:"ContentType";s:6:"normal";'
+                      's:10:"Importance";s:6:"Normal";'
+                      's:6:"Recent";s:1:" ";'
+                      's:6:"Unseen";s:1:"N";'
+                      's:8:"Answered";s:1:" ";'
+                      's:5:"Draft";s:1:" ";'
+                      's:7:"Deleted";s:1:" ";'
+                      's:7:"Flagged";b:0;'
+                      's:10:"msg_number";s:4:"2251";'
+                      's:5:"udate";s:10:"10/05/2011";'
+                      's:11:"offsetToGMT";i:-10800;'
+                      's:8:"aux_date";N;'
+                      's:4:"from";a:2:{'
+                         's:4:"name";s:10:"com.social";'
+                         's:5:"email";s:32:"comunicacao.social@serpro.gov.br";'
+                      '}'
+                      's:2:"to";a:2:{'
+                         's:4:"name";s:32:"comunicacao.social@serpro.gov.br";'
+                         's:5:"email";s:32:"comunicacao.social@serpro.gov.br";'
+                      '}'
+                      's:7:"subject";s:28:"Primeira leitura - 10/5/2011";'
+                      's:4:"Size";N;'
+                      's:10:"attachment";a:2:{'
+                         's:5:"names";b:0;'
+                         's:18:"number_attachments";i:0;'
+                      '}'
+                  '}'
+                  's:12:"array_attach";N;'
+                  's:15:"url_export_file";s:160:"inc/gotodownload.php?idx_file=/var/www/expressov2/expressoMail1_2/inc/../tmpLclAtt/source_38a3e960115351578aa182ae1d6c2b7b.txt&newfilename=fonte_da_mensagem.txt";'
+                  's:2:"to";N;'
+              '}';
    return(tplBody);
}

MAPattern.prototype.toExpressoMailDataHeader = function(msgid){
    var tplHMail = "";
    var tmpHead = expresso_mail_archive.getMessageHeaders(msgid);
    window.alert(tmpHead);
    return tplHMail;    
}

MAPattern.prototype.toExpressoMailData = function(msg){
    var tplBMail = "";
    
    return(tplBMail);
}

MAPattern.prototype.toExpressoMailAttachment = function(att){
    var objMsg = expresso_mail_archive.getMessageServiceObject(att);
    var attData = objMsg.getAttachments();
    var objAtt =  eval("(" + attData + ")");
    var srlData = "";

    //There are attachments
    if(typeof(objAtt.attachment) != 'undefined'){
        if(typeof(objAtt.attachment.length) != 'undefined'){
            srlData = 's:11:"attachments";a:' + objAtt.attachment.length + ':{';
            for(var m=0; m<objAtt.attachment.length; m++){
                srlData += 's:1:"' + m + '";'
                         + 'a:4:{'
                         + 's:3:"pid";s:' + objAtt.attachment[m]["@id"].length + ':"' + objAtt.attachment[m]["@id"] + '";'
                         + 's:4:"name";s:' + objAtt.attachment[m]["@name"].length + ':"' + objAtt.attachment[m]["@name"] + '";'
                         + 's:8:"encoding";s:' + objAtt.attachment[m]["@encoding"].length + ':"' + objAtt.attachment[m]["@encoding"] + '";'
                         + 's:5:"fsize";i:' + objAtt.attachment[m]["@size"] + ';'
                         + '}';
            }
        }
        //just one att
        else{
            srlData = 's:11:"attachments";a:1:{';
            srlData += 's:1:"0";'
                     + 'a:4:{'
                     + 's:3:"pid";s:' + objAtt.attachment["@id"].length + ':"' + objAtt.attachment["@id"] + '";'
                     + 's:4:"name";s:' + objAtt.attachment["@name"].length + ':"' + objAtt.attachment["@name"] + '";'
                     + 's:8:"encoding";s:' + objAtt.attachment["@encoding"].length + ':"' + objAtt.attachment["@encoding"] + '";'
                     + 's:5:"fsize";i:' + objAtt.attachment["@size"] + ';'
                     + '}';
        }
        srlData += '}';            
    }    
    //No attachments data
    else{
        srlData = 's:11:"attachments";N;';
    }
    return(srlData);
}

MAPattern.prototype.toExpressoMailThumbs = function(thb){
    var objMsg = expresso_mail_archive.getMessageServiceObject(thb);
    var attData = objMsg.getAttachments();
    var objAtt =  eval("(" + attData + ")");
    var srlData = "";
    var arrThumbs = new Array();
    if(typeof(objAtt.attachment) != 'undefined'){       
        //more than 1 att
        if(typeof(objAtt.attachment.length) != 'undefined'){
            for(var m=0; m<objAtt.attachment.length; m++){
                //Only images has thums
                if(objAtt.attachment[m]["@mediaType"].toLowerCase() == 'image')
                    arrThumbs.push(objAtt.attachment[m]);
            }
        }
        //just one att data
        else{
            if(objAtt.attachment["@mediaType"].toLowerCase() == 'image')
                arrThumbs.push(objAtt.attachment);
        }
        //There are thumbs
        if(arrThumbs.length > 0){
            srlData = 's:6:"thumbs";a:'+arrThumbs.length+':{'
            for(var n=0; n<arrThumbs.length; n++){
                var thumblink = '<a onMouseDown=\'save_image(event,this,"image/'+arrThumbs[n]["@subType"]+'")\' href=\'#INBOX;;2893;;0;;2;;'+arrThumbs[n]["@encoding"]+'\' onClick="window.open(\''+mail_archive_protocol+'://'+mail_archive_host+':'+mail_archive_port+'/part/'+arrThumbs[n]["@id"]+'\',\'mywindow\',\'width=700,height=600,scrollbars=yes\');"><IMG id=\'INBOX;;2893;;0;;2;;'+arrThumbs[n]["@encoding"]+'\' style=\'border:2px solid #fde7bc;padding:5px\' title=\'Clique na imagem para Ampliar.\' src="'+mail_archive_protocol+'://'+mail_archive_host+':'+mail_archive_port+'/part/'+arrThumbs[n]["@id"]+'/thumb/120"></a>';
                srlData += 's:1:"'+n+'";s:'+thumblink.length+':"'+thumblink+'";'
            }
            srlData += '}';    
        }
        //No thumbs
        else
            srlData = 's:6:"thumbs";N;';        
    }   
    //Something is wrong with attachments thumb behavior: return no thumbs
    else{
        srlData = 's:6:"thumbs";N;';
    }
    return(srlData);
}

MAPattern.prototype.toExpressoMailSignature = function(sgn){
    return('s:9:"signature";N;');
}

MAPattern.prototype.toExpressoMailBaseHeaders = function(hdr){
    var defMailHeaders = {'recent':' ','unseen': ' ','deleted': ' ','answered': ' ','draft': ' ','flagged': ' '};
    var objMsg = expresso_mail_archive.getMessageServiceObject(hdr);
    var tagData = objMsg.getTags();
    var objTag = eval('(' + tagData + ')');
    var tplHMail = "";

    //More than 1 attachment - because length will be 'undefined' if just one exists
    if(objTag.tag.length >= 0){

        //flaggs the tags
        for(var k=0; k<objTag.tag.length; k++){
            for(var j in defMailHeaders){
                var tagvalue = objTag.tag[k]["@value"].toLowerCase();
                if((tagvalue == j) && (defMailHeaders[j] != true))
                    defMailHeaders[j] = true;
                else
                    defMailHeaders[j] = false;
            }
        }
        
        //serialize all needed headers       
        if(defMailHeaders["recent"] == true)
            tplHMail += 's:6:"Recent";s:1:"N";';
        else
            tplHMail += 's:6:"Recent";s:1:" ";';
        if(defMailHeaders["unseen"] == true)
            tplHMail += 's:6:"Unseen";s:1:"U";';
        else
            tplHMail += 's:6:"Unseen";s:1:" ";';
        if(defMailHeaders["deleted"] == true)
            tplHMail += 's:7:"Deleted";s:1:"D";';
        else
            tplHMail += 's:7:"Deleted";s:1:" ";';
        if(defMailHeaders["answered"] == true)
            tplHMail += 's:8:"Answered";s:1:"A";';
        else
            tplHMail += 's:8:"Answered";s:1:" ";';
        if(defMailHeaders["draft"] == true)
            tplHMail += 's:5:"Draft";s:1:"X";';
        else
            tplHMail += 's:5:"Draft";s:1:" ";';        
        if(defMailHeaders["flagged"] == true)
            tplHMail += 's:7:"Flagged";s:1:"F";';
        else
            tplHMail += 's:7:"Flagged";s:1:" ";';                      
    }
    
    //No header to tag
    else{
        tplHMail += 's:6:"Recent";s:1:" ";';
        tplHMail += 's:6:"Unseen";s:1:" ";';
        tplHMail += 's:7:"Deleted";s:1:" ";';
        tplHMail += 's:8:"Answered";s:1:" ";';
        tplHMail += 's:5:"Draft";s:1:" ";';        
        tplHMail += 's:7:"Flagged";s:1:" ";';              
    }
    return tplHMail;        
}

MAPattern.prototype.toExpressoMailArrayAttach = function(att){
    var objMsg = expresso_mail_archive.getMessageServiceObject(att);
    var attData = objMsg.getAttachments();
    var objAtt =  eval("(" + attData + ")");
    var srlData = "";

    //There are attacments, map them
    if(typeof(objAtt.attachment) != 'undefined'){
        srlData = 's:12:"array_attach";a:' + objAtt.attachment.length + ':{';
        for(var m=0; m<objAtt.attachment.length; m++){
            //TODO "download" parametr at webservice => var urllink = 'http://10.200.242.186:4333/part/'+objAtt.attachment[m]["@id"]+'/download';
            //var urllink = 'http://10.200.242.186:4333/part/'+objAtt.attachment[m]["@id"];
            var urllink = mail_archive_protocol+'://'+mail_archive_host+':'+mail_archive_port+'/part/'+objAtt.attachment[m]["@id"];
            srlData += 's:1:"' + m + '";'
                     + 'a:3:{'
                     + 's:4:"name";s:' + objAtt.attachment[m]["@name"].length + ':"' + objAtt.attachment[m]["@name"] + '";'
                     + 's:3:"url";s:' + urllink.length + ':"' + urllink + '";'
                     + 's:3:"pid";s:' + objAtt.attachment[m]["@id"].length + ':"' + objAtt.attachment[m]["@id"] + '";'
                     + '}';
        }
        srlData += '}';
    }    
    //No one attachment
    else{
        srlData = 's:12:"array_attach";N;';
    }
    return(srlData);
}

MAPattern.prototype.toExpressoMailURLExportFile = function(path, file){
    var srlData = 's:15:"url_export_file";';
    //var urllink = 'http://10.200.242.186:4333/mail/'+path+'/'+file+'/download';
    //var urllink = 'http://10.200.242.186:4333/mail/'+path+'/'+file;
    var urllink = mail_archive_protocol+'://'+mail_archive_host+':'+mail_archive_port+'/mail/'+path+'/'+file;
    srlData += 's:' + urllink.length + ':"' + urllink + '";'
    return(srlData);
}

MAPattern.prototype.toExpressoMail = function(mheader, mbody){
    var tplMessage = null;
    var tplMessageData = null;
    var tplMessageHeaderData = null;  
    
    //Decodes message headers first
    var hdata = mheader;
    var h_date = expresso_mail_archive.pattern.toExpressoDate(mheader["udate"]*1000);
    
    //Init message template
    tplMessage = 'a:34{s:4:"body";N;'
+   expresso_mail_archive.pattern.toExpressoMailAttachment(expresso_mail_archive.currentmessage)
+   expresso_mail_archive.pattern.toExpressoMailThumbs(expresso_mail_archive.currentmessage)
+   expresso_mail_archive.pattern.toExpressoMailSignature(expresso_mail_archive.currentmessage)
+   expresso_mail_archive.pattern.toExpressoMailBaseHeaders(expresso_mail_archive.currentmessage)
+   's:5:"udate";s:8:"' + h_date.split(" ")[1] +'";' //hours
+   's:7:"msg_day";s:10:"'+ h_date.split(" ")[0] +'";' //date
+   's:8:"msg_hour";s:8:"' + h_date.split(" ")[1] +'";' //hours
+   's:8:"fulldate";s:19:"' + h_date +'";' //full date + hours
+   's:9:"smalldate";s:8:"' + h_date.split(" ")[1] +'";' //hours
+   's:10:"msg_number";s:'+expresso_mail_archive.currentmessage.length+':"'+expresso_mail_archive.currentmessage+'";'
+   's:10:"msg_folder";s:'+(expresso_mail_archive.currentfolder.length+6)+':"local_'+expresso_mail_archive.currentfolder+'";'
+   's:4:"from";N;'
+   's:6:"sender";N;'
+   's:9:"timestamp";i:'+ mheader["udate"]*1000 +';' //getback the lost miliseconds...
+   's:5:"login";i:944889240'
+   's:6:"header";' + expresso_mail_archive.pattern.toExpressoHeader(expresso_mail_archive.getMessageServiceObject(expresso_mail_archive.currentmessage)) 
+   expresso_mail_archive.pattern.toExpressoMailArrayAttach(expresso_mail_archive.currentmessage)
+   expresso_mail_archive.pattern.toExpressoMailURLExportFile(expresso_mail_archive.currentfolder, expresso_mail_archive.currentmessage)
+   's:2:"to";N;'
+   '}';

    var strMailMessage = connector.unserialize(tplMessage);
//    strMessage['from'] = mheader["from"];
    //strMessage['from'] = expresso_mail_archive.toExpressoBody(mheader, mbody);
//    strMessage['subject'] = mheader["subject"];
    strMailMessage['body'] = mbody;
//    strMessage['to'] = mheader["to"];
//    strMessage['cc'] = mheader["cc"];
    strMailMessage['local_message'] = true;
    strMailMessage['folder'] = 'local_' + expresso_mail_archive.currentfolder;
//    strMessage['msg_number'] = mheader["msg_number"];
  
    
    //window.alert('tplMessage = ' + tplMessage);
    return(strMailMessage);
}

MAPattern.prototype.toExpressoMessage = function(mheader, mbody){
    var strMessage = null;
    var strMessage1 = expresso_mail_archive.pattern.toExpressoBody(mheader);
    strMessage = connector.unserialize(strMessage1);
    
    window.alert('dump strMessage:\n\n' + print_r(strMessage,0));
    
    strMessage['from'] = mheader["from"];
    //strMessage['from'] = expresso_mail_archive.toExpressoBody(mheader, mbody);
    strMessage['subject'] = mheader["subject"];
    strMessage['body'] = mbody;
    strMessage['to'] = mheader["to"];
    strMessage['cc'] = mheader["cc"];
    strMessage['local_message'] = true;
    strMessage['folder'] = 'local_' + expresso_mail_archive.currentfolder;
    strMessage['msg_number'] = mheader["msg_number"];
    //window.alert('strMessage dump\n\n' + print_r(strMessage));
    return(strMessage);


/*
 *	retorno['from'] = connector.unserialize(rs.field(2));
	retorno['subject'] = rs.field(3);
	retorno['body'] = rs.field(4);
	//Codigo que as imagens embutidas em emails (com multipart/related ou multipart/mixed) sejam corretamente mostradas em emails arquivados. Os links do
	//tipo "./inc/show_embedded_attach.php?msg_folder=[folder]&msg_num=[msg_num]&msg_part=[part]"
	//são substituidos pelos links dos anexos capturados pelo gears.

	var thumbs= retorno.thumbs;
	var anexos= retorno.array_attach;
	for (i in anexos)
	{
	    if(anexos[i]['url'] && anexos[i]['url'].match(/((jpg)|(jpeg)|(png)|(gif)|(bmp))/gi))
	    {
		var er_imagens = new RegExp("\\.\\/inc\\/show_embedded_attach.php\\?msg_folder=[\\w/]+\\&msg_num=[0-9]+\\&msg_part="+anexos[i]['pid']);
		var Result_imagens = er_imagens.exec(retorno['body']);
		retorno['body'] = retorno['body'].replace(Result_imagens,anexos[i]['url']);
		if(thumbs && thumbs[i]){
		    er_imagens = new RegExp("\\.\\/inc\\/show_thumbs.php\\?file_type=image\\/[\\w]+\\&msg_num=[0-9]+\\&msg_folder=[\\w/%]+\\&msg_part="+anexos[i]['pid']);
		    Result_imagens = er_imagens.exec(thumbs[i]);
		    thumbs[i] = thumbs[i].replace(Result_imagens,"'"+anexos[i]['url']+"'");
		    er_imagens = new RegExp("\\.\\/inc\\/show_img.php\\?msg_num=[0-9]+\\&msg_folder=[\\w/%]+\\&msg_part="+anexos[i]['pid']);
		    Result_imagens = er_imagens.exec(thumbs[i]);
		    thumbs[i] = thumbs[i].replace(Result_imagens,anexos[i]['url']);
		    thumbs[i] = thumbs[i].replace(/<IMG/i,'<img width="120"');
		}
	    }
	}

	retorno['to'] = connector.unserialize(rs.field(5));
	retorno['cc'] = connector.unserialize(rs.field(6));

	retorno['local_message'] = true;
	retorno['msg_folder'] = "local_"+rs.field(7); //Now it's a local folder
	retorno['msg_number'] = rs.field(0)+plus_id; //the message number is the rowid
 **/    
}
-->